/* Copyright 2021 Neil Zaim
 *
 * This file is part of WarpX.
 *
 * License: BSD-3-Clause-LBNL
 */

#ifndef BINARY_COLLISION_UTILS_H_
#define BINARY_COLLISION_UTILS_H_

#include <string>

#include "Particles/MultiParticleContainer.H"

enum struct CollisionType { DeuteriumTritiumFusion, ProtonBoronFusion, Undefined };

enum struct NuclearFusionType { DeuteriumTritium, ProtonBoron, Undefined };

namespace BinaryCollisionUtils{

    NuclearFusionType get_nuclear_fusion_type (const std::string collision_name,
                                               MultiParticleContainer const * const mypc);

    CollisionType get_collision_type (const std::string collision_name,
                                      MultiParticleContainer const * const mypc);

    CollisionType nuclear_fusion_type_to_collision_type (const NuclearFusionType fusion_type);
}

#endif // BINARY_COLLISION_UTILS_H_
